GLM_GTX_dual_quaternion
Experimental extensions

Include <glm/gtx/dual_quaternion.hpp> to use the features of this extension. More...

## Typedefs

typedef highp_ddualquat | ddualquat
| Dual-quaternion of default double-qualifier floating-point numbers. More...
typedef highp_fdualquat | dualquat
| Dual-quaternion of floating-point numbers. More...
typedef highp_fdualquat | fdualquat
| Dual-quaternion of single-qualifier floating-point numbers. More...
typedef tdualquat< double, highp > | highp_ddualquat
| Dual-quaternion of high double-qualifier floating-point numbers. More...
typedef tdualquat< float, highp > | highp_dualquat
| Dual-quaternion of high single-qualifier floating-point numbers. More...
typedef tdualquat< float, highp > | highp_fdualquat
| Dual-quaternion of high single-qualifier floating-point numbers. More...
typedef tdualquat< double, lowp > | lowp_ddualquat
| Dual-quaternion of low double-qualifier floating-point numbers. More...
typedef tdualquat< float, lowp > | lowp_dualquat
| Dual-quaternion of low single-qualifier floating-point numbers. More...
typedef tdualquat< float, lowp > | lowp_fdualquat
| Dual-quaternion of low single-qualifier floating-point numbers. More...
typedef tdualquat< double, mediump > | mediump_ddualquat
| Dual-quaternion of medium double-qualifier floating-point numbers. More...
typedef tdualquat< float, mediump > | mediump_dualquat
| Dual-quaternion of medium single-qualifier floating-point numbers. More...
typedef tdualquat< float, mediump > | mediump_fdualquat
| Dual-quaternion of medium single-qualifier floating-point numbers. More...

## Functions

template<typename T , qualifier Q>
GLM_FUNC_DECL tdualquat< T, Q > | dual_quat_identity ()
| Creates an identity dual quaternion. More...
template<typename T , qualifier Q>
GLM_FUNC_DECL tdualquat< T, Q > | dualquat_cast (mat< 2, 4, T, Q > const &x)
| Converts a 2 * 4 matrix (matrix which holds real and dual parts) to a quaternion. More...
template<typename T , qualifier Q>
GLM_FUNC_DECL tdualquat< T, Q > | dualquat_cast (mat< 3, 4, T, Q > const &x)
| Converts a 3 * 4 matrix (augmented matrix rotation + translation) to a quaternion. More...
template<typename T , qualifier Q>
GLM_FUNC_DECL tdualquat< T, Q > | inverse (tdualquat< T, Q > const &q)
| Returns the q inverse. More...
template<typename T , qualifier Q>
GLM_FUNC_DECL tdualquat< T, Q > | lerp (tdualquat< T, Q > const &x, tdualquat< T, Q > const &y, T const &a)
| Returns the linear interpolation of two dual quaternion. More...
template<typename T , qualifier Q>
GLM_FUNC_DECL mat< 2, 4, T, Q > | mat2x4_cast (tdualquat< T, Q > const &x)
| Converts a quaternion to a 2 * 4 matrix. More...
template<typename T , qualifier Q>
GLM_FUNC_DECL mat< 3, 4, T, Q > | mat3x4_cast (tdualquat< T, Q > const &x)
| Converts a quaternion to a 3 * 4 matrix. More...
template<typename T , qualifier Q>
GLM_FUNC_DECL tdualquat< T, Q > | normalize (tdualquat< T, Q > const &q)
| Returns the normalized quaternion. More...

## Detailed Description

Include <glm/gtx/dual_quaternion.hpp> to use the features of this extension.

Defines a templated dual-quaternion type and several dual-quaternion operations.

## Typedef Documentation

typedef highp_ddualquat ddualquat

Dual-quaternion of default double-qualifier floating-point numbers.

See also
  GLM_GTX_dual_quaternion

Definition at line 260 of file dual_quaternion.hpp.

typedef highp_fdualquat dualquat

Dual-quaternion of floating-point numbers.

See also
  GLM_GTX_dual_quaternion

Definition at line 236 of file dual_quaternion.hpp.

typedef highp_fdualquat fdualquat

Dual-quaternion of single-qualifier floating-point numbers.

See also
  GLM_GTX_dual_quaternion

Definition at line 241 of file dual_quaternion.hpp.

typedef tdualquat<double, highp> highp_ddualquat

Dual-quaternion of high double-qualifier floating-point numbers.

See also
  GLM_GTX_dual_quaternion

Definition at line 229 of file dual_quaternion.hpp.

typedef tdualquat<float, highp> highp_dualquat

Dual-quaternion of high single-qualifier floating-point numbers.

See also
  GLM_GTX_dual_quaternion

Definition at line 197 of file dual_quaternion.hpp.

typedef tdualquat<float, highp> highp_fdualquat

Dual-quaternion of high single-qualifier floating-point numbers.

See also
  GLM_GTX_dual_quaternion

Definition at line 213 of file dual_quaternion.hpp.

typedef tdualquat<double, lowp> lowp_ddualquat

Dual-quaternion of low double-qualifier floating-point numbers.

See also
  GLM_GTX_dual_quaternion

Definition at line 219 of file dual_quaternion.hpp.

typedef tdualquat<float, lowp> lowp_dualquat

Dual-quaternion of low single-qualifier floating-point numbers.

See also
  GLM_GTX_dual_quaternion

Definition at line 187 of file dual_quaternion.hpp.

typedef tdualquat<float, lowp> lowp_fdualquat

Dual-quaternion of low single-qualifier floating-point numbers.

See also
  GLM_GTX_dual_quaternion

Definition at line 203 of file dual_quaternion.hpp.

typedef tdualquat<double, mediump> mediump_ddualquat

Dual-quaternion of medium double-qualifier floating-point numbers.

See also
  GLM_GTX_dual_quaternion

Definition at line 224 of file dual_quaternion.hpp.

typedef tdualquat<float, mediump> mediump_dualquat

Dual-quaternion of medium single-qualifier floating-point numbers.

See also
  GLM_GTX_dual_quaternion

Definition at line 192 of file dual_quaternion.hpp.

typedef tdualquat<float, mediump> mediump_fdualquat

Dual-quaternion of medium single-qualifier floating-point numbers.

See also
  GLM_GTX_dual_quaternion

Definition at line 208 of file dual_quaternion.hpp.

## Function Documentation

GLM_FUNC_DECL tdualquat<T, Q> glm::dual_quat_identity | ( |  | ) |

Creates an identity dual quaternion.

See also
  GLM_GTX_dual_quaternion

GLM_FUNC_DECL tdualquat<T, Q> glm::dualquat_cast | ( | mat< 2, 4, T, Q > const & | x | ) |

Converts a 2 * 4 matrix (matrix which holds real and dual parts) to a quaternion.

See also
  GLM_GTX_dual_quaternion

GLM_FUNC_DECL tdualquat<T, Q> glm::dualquat_cast | ( | mat< 3, 4, T, Q > const & | x | ) |

Converts a 3 * 4 matrix (augmented matrix rotation + translation) to a quaternion.

See also
  GLM_GTX_dual_quaternion

GLM_FUNC_DECL tdualquat<T, Q> glm::inverse | ( | tdualquat< T, Q > const & | q | ) |

Returns the q inverse.

See also
  GLM_GTX_dual_quaternion

GLM_FUNC_DECL tdualquat<T, Q> glm::lerp | ( | tdualquat< T, Q > const & | x,
|  | tdualquat< T, Q > const & | y,
|  | T const & | a
| ) |  |

Returns the linear interpolation of two dual quaternion.

See also
  gtc_dual_quaternion

GLM_FUNC_DECL mat<2, 4, T, Q> glm::mat2x4_cast | ( | tdualquat< T, Q > const & | x | ) |

Converts a quaternion to a 2 * 4 matrix.

See also
  GLM_GTX_dual_quaternion

GLM_FUNC_DECL mat<3, 4, T, Q> glm::mat3x4_cast | ( | tdualquat< T, Q > const & | x | ) |

Converts a quaternion to a 3 * 4 matrix.

See also
  GLM_GTX_dual_quaternion

GLM_FUNC_DECL tdualquat<T, Q> glm::normalize | ( | tdualquat< T, Q > const & | q | ) |

Returns the normalized quaternion.

See also
  GLM_GTX_dual_quaternion